make user-defined macros available at runtime
[bpt/guile.git] / maint.mk
CommitLineData
c84bdaf6
LC
1# -*-Makefile-*-
2# This Makefile fragment tries to be general-purpose enough to be
3# used by many projects via the gnulib maintainer-makefile module.
4
61cd9dc9 5## Copyright (C) 2001-2010 Free Software Foundation, Inc.
c84bdaf6
LC
6##
7## This program is free software: you can redistribute it and/or modify
8## it under the terms of the GNU General Public License as published by
9## the Free Software Foundation, either version 3 of the License, or
10## (at your option) any later version.
11##
12## This program is distributed in the hope that it will be useful,
13## but WITHOUT ANY WARRANTY; without even the implied warranty of
14## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15## GNU General Public License for more details.
16##
17## You should have received a copy of the GNU General Public License
18## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20# This is reported not to work with make-3.79.1
21# ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22ME := maint.mk
23
24# Override this in cfg.mk if you use a non-standard build-aux directory.
25build_aux ?= $(srcdir)/build-aux
26
27# Do not save the original name or timestamp in the .tar.gz file.
28# Use --rsyncable if available.
29gzip_rsyncable := \
a927b6c1
LC
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31 && printf %s --rsyncable)
c84bdaf6
LC
32GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33
c84bdaf6
LC
34GIT = git
35VC = $(GIT)
36VC-tag = git tag -s -m '$(VERSION)' -u '$(gpg_key_ID)'
37
38VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
39
61cd9dc9
LC
40# You can override this variable in cfg.mk to set your own regexp
41# matching files to ignore.
42VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
43
44# This is to preprocess robustly the output of $(VC_LIST), so that even
45# when $(srcdir) is a pathological name like "....", the leading sed command
46# removes only the intended prefix.
47_dot_escaped_srcdir = $(subst .,\.,$(srcdir))
48
49# Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
50# when $(srcdir) is not ".".
51ifeq ($(srcdir),.)
52_prepend_srcdir_prefix =
53else
54_prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
55endif
56
57# In order to be able to consistently filter "."-relative names,
58# (i.e., with no $(srcdir) prefix), this definition is careful to
59# remove any $(srcdir) prefix, and to restore what it removes.
c84bdaf6 60VC_LIST_EXCEPT = \
61cd9dc9
LC
61 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
62 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
63 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
64 | grep -Ev -e '$(VC_LIST_ALWAYS_EXCLUDE_REGEX)' \
65 $(_prepend_srcdir_prefix)
c84bdaf6
LC
66
67ifeq ($(origin prev_version_file), undefined)
68 prev_version_file = $(srcdir)/.prev-version
69endif
70
71PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
72VERSION_REGEXP = $(subst .,\.,$(VERSION))
73PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
74
75ifeq ($(VC),$(GIT))
76this-vc-tag = v$(VERSION)
77this-vc-tag-regexp = v$(VERSION_REGEXP)
78else
79tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
80tag-this-version = $(subst .,_,$(VERSION))
81this-vc-tag = $(tag-package)-$(tag-this-version)
82this-vc-tag-regexp = $(this-vc-tag)
83endif
84my_distdir = $(PACKAGE)-$(VERSION)
85
86# Old releases are stored here.
87release_archive_dir ?= ../release
88
414e4441
LC
89# Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
90# Use alpha.gnu.org for alpha and beta releases.
91# Use ftp.gnu.org for stable releases.
92gnu_ftp_host-alpha = alpha.gnu.org
93gnu_ftp_host-beta = alpha.gnu.org
94gnu_ftp_host-stable = ftp.gnu.org
95gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
96
97ifeq ($(gnu_rel_host),ftp.gnu.org)
98url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
99else
100url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
101endif
102
1cd4fffc
LC
103# Override this in cfg.mk if you are using a different format in your
104# NEWS file.
105today = $(shell date +%Y-%m-%d)
9157d901
LC
106
107# Select which lines of NEWS are searched for $(news-check-regexp).
108# This is a sed line number spec. The default says that we search
109# lines 1..10 of NEWS for $(news-check-regexp).
110# If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
111news-check-lines-spec ?= 1,10
1cd4fffc
LC
112news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
113
c84bdaf6
LC
114# Prevent programs like 'sort' from considering distinct strings to be equal.
115# Doing it here saves us from having to set LC_ALL elsewhere in this file.
116export LC_ALL = C
117
118## --------------- ##
119## Sanity checks. ##
120## --------------- ##
121
122_cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
123
124# Collect the names of rules starting with `sc_'.
125syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
126 $(srcdir)/$(ME) $(_cfg_mk)))
127.PHONY: $(syntax-check-rules)
128
129local-checks-available = \
130 $(syntax-check-rules)
131.PHONY: $(local-checks-available)
132
133# Arrange to print the name of each syntax-checking rule just before running it.
134$(syntax-check-rules): %: %.m
dde9c5a4
LC
135sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
136.PHONY: $(sc_m_rules_)
137$(sc_m_rules_):
c84bdaf6 138 @echo $(patsubst sc_%.m, %, $@)
a927b6c1
LC
139 @date +%s.%N > .sc-start-$(basename $@)
140
141# Compute and print the elapsed time for each syntax-check rule.
142sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
143.PHONY: $(sc_z_rules_)
144$(sc_z_rules_): %.z: %
145 @end=$$(date +%s.%N); \
146 start=$$(cat .sc-start-$*); \
147 rm -f .sc-start-$*; \
148 awk -v s=$$start -v e=$$end \
149 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
150
151# The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
152# that computes and prints elapsed time.
153local-check := \
154 $(patsubst sc_%, sc_%.z, \
155 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
c84bdaf6
LC
156
157syntax-check: $(local-check)
a927b6c1
LC
158
159# _sc_search_regexp
160#
161# This macro searches for a given construct in the selected files and
162# then takes some action.
163#
164# Parameters (shell variables):
165#
166# prohibit | require
167#
168# Regular expression (ERE) denoting either a forbidden construct
169# or a required construct. Those arguments are exclusive.
170#
171# in_vc_files | in_files
172#
173# grep-E-style regexp denoting the files to check. If no files
174# are specified the default are all the files that are under
175# version control.
176#
177# containing | non_containing
178#
179# Select the files (non) containing strings matching this regexp.
180# If both arguments are specified then CONTAINING takes
181# precedence.
182#
183# with_grep_options
184#
185# Extra options for grep.
186#
187# ignore_case
188#
189# Ignore case.
190#
191# halt
192#
193# Message to display before to halting execution.
194
195# By default, _sc_search_regexp does not ignore case.
c84bdaf6 196export ignore_case =
a927b6c1 197_ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
c84bdaf6 198
a927b6c1
LC
199define _sc_say_and_exit
200 dummy=; : so we do not need a semicolon before each use; \
201 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
202endef
203
204# _sc_search_regexp used to be named _prohibit_regexp. However,
205# upgrading to the new definition and leaving the old name undefined
206# would usually convert each custom rule using $(_prohibit_regexp)
207# (usually defined in cfg.mk) into a no-op. This definition ensures
208# that people know right away if they're still using the old name.
209# FIXME: remove in 2012.
210_prohibit_regexp = \
211 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
212
213define _sc_search_regexp
214 dummy=; : so we do not need a semicolon before each use; \
215 \
216 : Check arguments; \
217 test -n "$$prohibit" && test -n "$$require" \
218 && { msg='Cannot specify both prohibit and require' \
219 $(_sc_say_and_exit) } || :; \
220 test -z "$$prohibit" && test -z "$$require" \
221 && { msg='Should specify either prohibit or require' \
222 $(_sc_say_and_exit) } || :; \
223 test -n "$$in_vc_files" && test -n "$$in_files" \
224 && { msg='Cannot specify both in_vc_files and in_files' \
225 $(_sc_say_and_exit) } || :; \
226 test "x$$halt" != x \
227 || { msg='halt not defined' $(_sc_say_and_exit) }; \
228 \
229 : Filter by file name; \
230 if test -n "$$in_files"; then \
231 files=$$(find $(srcdir) | grep -E "$$in_files"); \
232 else \
233 files=$$($(VC_LIST_EXCEPT)); \
234 if test -n "$$in_vc_files"; then \
235 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
236 fi; \
237 fi; \
238 \
239 : Filter by content; \
240 test -n "$$files" && test -n "$$containing" \
241 && { files=$$(grep -l "$$containing" $$files); } || :; \
242 test -n "$$files" && test -n "$$non_containing" \
243 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
244 \
245 : Check for the construct; \
246 if test -n "$$files"; then \
247 if test -n "$$prohibit"; then \
248 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
249 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
250 else \
251 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
252 | grep . \
253 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
254 fi \
255 else :; \
256 fi || :;
c84bdaf6
LC
257endef
258
259sc_avoid_if_before_free:
260 @$(build_aux)/useless-if-before-free \
261 $(useless_free_options) \
262 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
263 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
264 exit 1; } || :
265
266sc_cast_of_argument_to_free:
a927b6c1
LC
267 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
268 $(_sc_search_regexp)
c84bdaf6
LC
269
270sc_cast_of_x_alloc_return_value:
a927b6c1
LC
271 @prohibit='\*\) *x(m|c|re)alloc\>' \
272 halt='don'\''t cast x*alloc return value' \
273 $(_sc_search_regexp)
c84bdaf6
LC
274
275sc_cast_of_alloca_return_value:
a927b6c1
LC
276 @prohibit='\*\) *alloca\>' \
277 halt='don'\''t cast alloca return value' \
278 $(_sc_search_regexp)
c84bdaf6
LC
279
280sc_space_tab:
a927b6c1
LC
281 @prohibit='[ ] ' \
282 halt='found SPACE-TAB sequence; remove the SPACE' \
283 $(_sc_search_regexp)
c84bdaf6
LC
284
285# Don't use *scanf or the old ato* functions in `real' code.
286# They provide no error checking mechanism.
287# Instead, use strto* functions.
288sc_prohibit_atoi_atof:
a927b6c1
LC
289 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
290 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
291 $(_sc_search_regexp)
c84bdaf6
LC
292
293# Use STREQ rather than comparing strcmp == 0, or != 0.
294sc_prohibit_strcmp:
295 @grep -nE '! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
296 $$($(VC_LIST_EXCEPT)) \
297 | grep -vE ':# *define STREQ\(' && \
298 { echo '$(ME): use STREQ in place of the above uses of str''cmp' \
299 1>&2; exit 1; } || :
300
301# Pass EXIT_*, not number, to usage, exit, and error (when exiting)
414e4441
LC
302# Convert all uses automatically, via these two commands:
303# git grep -l '\<exit *(1)' \
304# | grep -vEf .x-sc_prohibit_magic_number_exit \
305# | xargs --no-run-if-empty \
306# perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
307# git grep -l '\<exit *(0)' \
308# | grep -vEf .x-sc_prohibit_magic_number_exit \
309# | xargs --no-run-if-empty \
310# perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
c84bdaf6 311sc_prohibit_magic_number_exit:
a927b6c1
LC
312 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
313 halt='use EXIT_* values rather than magic number' \
314 $(_sc_search_regexp)
c84bdaf6
LC
315
316# Using EXIT_SUCCESS as the first argument to error is misleading,
317# since when that parameter is 0, error does not exit. Use `0' instead.
318sc_error_exit_success:
a927b6c1
LC
319 @prohibit='error *\(EXIT_SUCCESS,' \
320 in_vc_files='\.[chly]$$' \
321 halt='found error (EXIT_SUCCESS' \
322 $(_sc_search_regexp)
c84bdaf6
LC
323
324# `FATAL:' should be fully upper-cased in error messages
325# `WARNING:' should be fully upper-cased, or fully lower-cased
326sc_error_message_warn_fatal:
a927b6c1 327 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
328 | grep -E '"Warning|"Fatal|"fatal' && \
329 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
330 exit 1; } || :
331
332# Error messages should not start with a capital letter
333sc_error_message_uppercase:
a927b6c1 334 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
335 | grep -E '"[A-Z]' \
336 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
337 { echo '$(ME): found capitalized error message' 1>&2; \
338 exit 1; } || :
339
340# Error messages should not end with a period
341sc_error_message_period:
a927b6c1 342 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
343 | grep -E '[^."]\."' && \
344 { echo '$(ME): found error message ending in period' 1>&2; \
345 exit 1; } || :
346
347sc_file_system:
a927b6c1
LC
348 @prohibit=file''system \
349 ignore_case=1 \
350 halt='found use of "file''system"; spell it "file system"' \
351 $(_sc_search_regexp)
c84bdaf6
LC
352
353# Don't use cpp tests of this symbol. All code assumes config.h is included.
354sc_prohibit_have_config_h:
a927b6c1
LC
355 @prohibit='^# *if.*HAVE''_CONFIG_H' \
356 halt='found use of HAVE''_CONFIG_H; remove' \
357 $(_sc_search_regexp)
c84bdaf6
LC
358
359# Nearly all .c files must include <config.h>. However, we also permit this
360# via inclusion of a package-specific header, if cfg.mk specified one.
361# config_h_header must be suitable for grep -E.
362config_h_header ?= <config\.h>
363sc_require_config_h:
a927b6c1
LC
364 @require='^# *include $(config_h_header)' \
365 in_vc_files='\.c$$' \
366 halt='the above files do not include <config.h>' \
367 $(_sc_search_regexp)
c84bdaf6
LC
368
369# You must include <config.h> before including any other header file.
370# This can possibly be via a package-specific header, if given by cfg.mk.
371sc_require_config_h_first:
372 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
373 fail=0; \
374 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
375 grep '^# *include\>' $$i | sed 1q \
376 | grep -E '^# *include $(config_h_header)' > /dev/null \
377 || { echo $$i; fail=1; }; \
378 done; \
379 test $$fail = 1 && \
380 { echo '$(ME): the above files include some other header' \
381 'before <config.h>' 1>&2; exit 1; } || :; \
382 else :; \
383 fi
384
385sc_prohibit_HAVE_MBRTOWC:
a927b6c1
LC
386 @prohibit='\bHAVE_MBRTOWC\b' \
387 halt="do not use $$prohibit; it is always defined" \
388 $(_sc_search_regexp)
c84bdaf6
LC
389
390# To use this "command" macro, you must first define two shell variables:
391# h: the header, enclosed in <> or ""
392# re: a regular expression that matches IFF something provided by $h is used.
a927b6c1 393define _sc_header_without_use
c84bdaf6
LC
394 dummy=; : so we do not need a semicolon before each use; \
395 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
396 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
397 files=$$(grep -l '^# *include '"$$h_esc" \
398 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
399 grep -LE "$$re" $$files | grep . && \
400 { echo "$(ME): the above files include $$h but don't use it" \
401 1>&2; exit 1; } || :; \
402 else :; \
403 fi
404endef
405
406# Prohibit the inclusion of assert.h without an actual use of assert.
407sc_prohibit_assert_without_use:
a927b6c1 408 @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
c84bdaf6
LC
409
410# Prohibit the inclusion of close-stream.h without an actual use.
411sc_prohibit_close_stream_without_use:
a927b6c1 412 @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
c84bdaf6
LC
413
414# Prohibit the inclusion of getopt.h without an actual use.
415sc_prohibit_getopt_without_use:
a927b6c1 416 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
417
418# Don't include quotearg.h unless you use one of its functions.
419sc_prohibit_quotearg_without_use:
a927b6c1 420 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
421
422# Don't include quote.h unless you use one of its functions.
423sc_prohibit_quote_without_use:
a927b6c1 424 @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
425
426# Don't include this header unless you use one of its functions.
427sc_prohibit_long_options_without_use:
428 @h='"long-options.h"' re='\<parse_long_options *\(' \
a927b6c1 429 $(_sc_header_without_use)
c84bdaf6
LC
430
431# Don't include this header unless you use one of its functions.
432sc_prohibit_inttostr_without_use:
433 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
a927b6c1 434 $(_sc_header_without_use)
c84bdaf6 435
61cd9dc9
LC
436# Don't include this header unless you use one of its functions.
437sc_prohibit_ignore_value_without_use:
438 @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
a927b6c1 439 $(_sc_header_without_use)
61cd9dc9 440
c84bdaf6
LC
441# Don't include this header unless you use one of its functions.
442sc_prohibit_error_without_use:
443 @h='"error.h"' \
444 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
a927b6c1 445 $(_sc_header_without_use)
c84bdaf6
LC
446
447# Don't include xalloc.h unless you use one of its functions.
448# Consider these symbols:
449# perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
a927b6c1 450# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
c84bdaf6
LC
451# Divide into two sets on case, and filter each through this:
452# | sort | perl -MRegexp::Assemble -le \
453# 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
454# Note this was produced by the above:
61cd9dc9
LC
455# _xa1 = \
456#x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
457# But we can do better, in at least two ways:
458# 1) take advantage of two "dup"-suffixed strings:
459# x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
460# 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
461# "char|[cmz]"
462# x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
463_xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
c84bdaf6
LC
464_xa2 = X([CZ]|N?M)ALLOC
465sc_prohibit_xalloc_without_use:
466 @h='"xalloc.h"' \
467 re='\<($(_xa1)|$(_xa2)) *\('\
a927b6c1 468 $(_sc_header_without_use)
c84bdaf6 469
dde9c5a4 470# Extract function names:
a927b6c1 471# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
dde9c5a4
LC
472_hash_re = \
473clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
474_hash_fn = \<($(_hash_re)) *\(
475_hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
476sc_prohibit_hash_without_use:
477 @h='"hash.h"' \
478 re='$(_hash_fn)|$(_hash_struct)'\
a927b6c1 479 $(_sc_header_without_use)
dde9c5a4
LC
480
481sc_prohibit_hash_pjw_without_use:
482 @h='"hash-pjw.h"' \
483 re='\<hash_pjw *\(' \
a927b6c1 484 $(_sc_header_without_use)
dde9c5a4 485
c84bdaf6
LC
486sc_prohibit_safe_read_without_use:
487 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
a927b6c1 488 $(_sc_header_without_use)
c84bdaf6
LC
489
490sc_prohibit_argmatch_without_use:
491 @h='"argmatch.h"' \
492 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
a927b6c1 493 $(_sc_header_without_use)
c84bdaf6
LC
494
495sc_prohibit_canonicalize_without_use:
496 @h='"canonicalize.h"' \
497 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
a927b6c1 498 $(_sc_header_without_use)
c84bdaf6
LC
499
500sc_prohibit_root_dev_ino_without_use:
501 @h='"root-dev-ino.h"' \
502 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
a927b6c1 503 $(_sc_header_without_use)
c84bdaf6
LC
504
505sc_prohibit_openat_without_use:
506 @h='"openat.h"' \
507 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
a927b6c1 508 $(_sc_header_without_use)
c84bdaf6
LC
509
510# Prohibit the inclusion of c-ctype.h without an actual use.
511ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
512|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
513sc_prohibit_c_ctype_without_use:
a927b6c1
LC
514 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
515 $(_sc_header_without_use)
c84bdaf6
LC
516
517_empty =
518_sp = $(_empty) $(_empty)
519# The following list was generated by running:
520# man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
521# | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
522_sig_functions = \
523 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
524 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
525 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
526 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
527_sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
528# The following were extracted from "man signal.h" manually.
529_sig_types_and_consts = \
530 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
531 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
532 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
533 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
534 sigstack sigval stack_t ucontext_t
535# generated via this:
536# perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
537_sig_names = \
538 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
539 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
540 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
541 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
542 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
543 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
544 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
545 SIGXCPU SIGXFSZ
546_sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
547
548# Prohibit the inclusion of signal.h without an actual use.
549sc_prohibit_signal_without_use:
550 @h='<signal.h>' \
551 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
a927b6c1
LC
552 $(_sc_header_without_use)
553
554# Prohibit the inclusion of strings.h without a sensible use.
555# Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
556sc_prohibit_strings_without_use:
557 @h='<strings.h>' \
558 re='\<(strn?casecmp|ffs(ll)?)\>' \
559 $(_sc_header_without_use)
560
561# Get the list of symbol names with this:
562# perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
563_intprops_names = \
564 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
565 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
566 INT_STRLEN_BOUND INT_BUFSIZE_BOUND
567_intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
568# Prohibit the inclusion of intprops.h without an actual use.
569sc_prohibit_intprops_without_use:
570 @h='"intprops.h"' \
571 re='\<($(_intprops_syms_re)) *\(' \
572 $(_sc_header_without_use)
c84bdaf6
LC
573
574sc_obsolete_symbols:
a927b6c1
LC
575 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
576 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
577 $(_sc_search_regexp)
c84bdaf6
LC
578
579# FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
580
581# Each nonempty ChangeLog line must start with a year number, or a TAB.
582sc_changelog:
a927b6c1
LC
583 @prohibit='^[^12 ]' \
584 in_vc_files='^ChangeLog$$' \
585 halt='found unexpected prefix in a ChangeLog' \
586 $(_sc_search_regexp)
c84bdaf6
LC
587
588# Ensure that each .c file containing a "main" function also
589# calls set_program_name.
590sc_program_name:
a927b6c1
LC
591 @require='set_program_name *\(m?argv\[0\]\);' \
592 in_vc_files='\.c$$' \
593 containing='^main *(' \
594 halt='the above files do not call set_program_name' \
595 $(_sc_search_regexp)
c84bdaf6
LC
596
597# Require that the final line of each test-lib.sh-using test be this one:
598# Exit $fail
599# Note: this test requires GNU grep's --label= option.
600Exit_witness_file ?= tests/test-lib.sh
601Exit_base := $(notdir $(Exit_witness_file))
602sc_require_test_exit_idiom:
603 @if test -f $(srcdir)/$(Exit_witness_file); then \
604 die=0; \
605 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
606 $$($(VC_LIST) tests)); do \
607 tail -n1 $$i | grep '^Exit .' > /dev/null \
608 && : || { die=1; echo $$i; } \
609 done; \
610 test $$die = 1 && \
611 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
612 echo 1>&2 'Exit something'; \
613 exit 1; } || :; \
614 fi
615
616sc_the_the:
a927b6c1
LC
617 @prohibit='\<the ''the\>' \
618 ignore_case=1 \
619 halt='found use of "the ''the";' \
620 $(_sc_search_regexp)
c84bdaf6
LC
621
622sc_trailing_blank:
a927b6c1
LC
623 @prohibit='[ ]$$' \
624 halt='found trailing blank(s)' \
625 $(_sc_search_regexp)
c84bdaf6
LC
626
627# Match lines like the following, but where there is only one space
628# between the options and the description:
629# -D, --all-repeated[=delimit-method] print all duplicate lines\n
630longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
631sc_two_space_separator_in_usage:
a927b6c1
LC
632 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
633 halt='help2man requires at least two spaces between an option and its description'\
634 $(_sc_search_regexp)
c84bdaf6
LC
635
636# Look for diagnostics that aren't marked for translation.
637# This won't find any for which error's format string is on a separate line.
638sc_unmarked_diagnostics:
639 @grep -nE \
a927b6c1 640 '\<error *\([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
641 | grep -v '_''(' && \
642 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
643 exit 1; } || :
644
645# Avoid useless parentheses like those in this example:
646# #if defined (SYMBOL) || defined (SYM2)
647sc_useless_cpp_parens:
a927b6c1
LC
648 @prohibit='^# *if .*defined *\(' \
649 halt='found useless parentheses in cpp directive' \
650 $(_sc_search_regexp)
651
652# List headers for which HAVE_HEADER_H is always true, assuming you are
653# using the appropriate gnulib module. CAUTION: for each "unnecessary"
654# #if HAVE_HEADER_H that you remove, be sure that your project explicitly
655# requires the gnulib module that guarantees the usability of that header.
656gl_assured_headers_ = \
657 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
658
659# Convert the list of names to upper case, and replace each space with "|".
660az_ = abcdefghijklmnopqrstuvwxyz
661AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
662gl_header_upper_case_or_ = \
663 $$($(gl_assured_headers_) \
664 | tr $(az_)/.- $(AZ_)___ \
665 | tr -s ' ' '|' \
666 )
667sc_prohibit_always_true_header_tests:
668 @or=$(gl_header_upper_case_or_); \
669 re="HAVE_($$or)_H"; \
670 prohibit='\<'"$$re"'\>' \
671 halt='do not test the above HAVE_<header>_H symbol(s);\n'\
672' with the corresponding gnulib module, they are always true' \
673 $(_sc_search_regexp)
674
675# ==================================================================
676gl_other_headers_ ?= \
677 intprops.h \
678 openat.h \
679 stat-macros.h
680
681# Perl -lne code to extract "significant" cpp-defined symbols from a
682# gnulib header file, eliminating a few common false-positives.
683gl_extract_significant_defines_ = \
684 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
685 && $$2 !~ /(?:rpl_|_used_without_)/\
686 && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
687 and print $$1
688
689# Create a list of regular expressions matching the names
690# of macros that are guaranteed to be defined by parts of gnulib.
691define def_sym_regex
692 gen_h=$(gl_generated_headers_); \
693 (cd $(gnulib_dir)/lib; \
694 for f in *.in.h $(gl_other_headers_); do \
695 perl -lne '$(gl_extract_significant_defines_)' $$f; \
696 done; \
697 ) | sort -u \
698 | grep -Ev '^ATTRIBUTE_NORETURN' \
699 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
700endef
701
702# Don't define macros that we already get from gnulib header files.
703sc_prohibit_always-defined_macros:
704 @if test -d $(gnulib_dir); then \
705 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
706 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
707 esac; \
708 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
709 && { echo '$(ME): define the above via some gnulib .h file' \
710 1>&2; exit 1; } || :; \
711 fi
712# ==================================================================
713
714# Prohibit checked in backup files.
715sc_prohibit_backup_files:
716 @$(VC_LIST) | grep '~$$' && \
717 { echo '$(ME): found version controlled backup file' 1>&2; \
718 exit 1; } || :
c84bdaf6
LC
719
720# Require the latest GPL.
721sc_GPL_version:
a927b6c1
LC
722 @prohibit='either ''version [^3]' \
723 halt='GPL vN, N!=3' \
724 $(_sc_search_regexp)
c84bdaf6 725
61cd9dc9
LC
726# Require the latest GFDL. Two regexp, since some .texi files end up
727# line wrapping between 'Free Documentation License,' and 'Version'.
728_GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
729sc_GFDL_version:
a927b6c1
LC
730 @prohibit='$(_GFDL_regexp)' \
731 halt='GFDL vN, N!=3' \
732 $(_sc_search_regexp)
733
734# Don't use Texinfo @acronym{} as it is not a good idea.
735texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
736sc_texinfo_acronym:
737 @prohibit='@acronym\{' \
738 in_vc_files='$(texinfo_suffix_re_)' \
739 halt='found use of Texinfo @acronym{}' \
740 $(_sc_search_regexp)
61cd9dc9 741
c84bdaf6
LC
742cvs_keywords = \
743 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
744
745sc_prohibit_cvs_keyword:
a927b6c1
LC
746 @prohibit='\$$($(cvs_keywords))\$$' \
747 halt='do not use CVS keyword expansion' \
748 $(_sc_search_regexp)
749
750# This Perl code is slightly obfuscated. Not only is each "$" doubled
751# because it's in a Makefile, but the $$c's are comments; we cannot
752# use "#" due to the way the script ends up concatenated onto one line.
753# It would be much more concise, and would produce better output (including
754# counts) if written as:
755# perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
756# but that would be far less efficient, reading the entire contents
757# of each file, rather than just the last two bytes of each.
758#
759# This is a perl script that is expected to be the single-quoted argument
760# to a command-line "-le". The remaining arguments are file names.
761# Print the name of each file that ends in two or more newline bytes.
762# Exit nonzero if at least one such file is found, otherwise, exit 0.
763# Warn about, but otherwise ignore open failure. Ignore seek/read failure.
764#
765# Use this if you want to remove trailing empty lines from selected files:
766# perl -pi -0777 -e 's/\n\n+$/\n/' files...
767#
768detect_empty_lines_at_EOF_ = \
769 foreach my $$f (@ARGV) \
770 { \
771 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
772 my $$p = sysseek (F, -2, 2); \
773 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
774 my $$last_two_bytes; \
775 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
776 close F; \
777 $$c = "ignore read failure"; \
778 $$p && $$last_two_bytes eq "\n\n" and (print $$f), $$fail=1; \
779 } \
780 END { exit defined $$fail }
781sc_prohibit_empty_lines_at_EOF:
782 @perl -le '$(detect_empty_lines_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
783 || { echo '$(ME): the above files end with empty line(s)' \
784 1>&2; exit 1; } || :; \
c84bdaf6
LC
785
786# Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
787# This is a bit of a kludge, since it prevents use of the string
788# even in comments, but for now it does the job with no false positives.
789sc_prohibit_stat_st_blocks:
a927b6c1
LC
790 @prohibit='[.>]st_blocks' \
791 halt='do not use st_blocks; use ST_NBLOCKS' \
792 $(_sc_search_regexp)
c84bdaf6
LC
793
794# Make sure we don't define any S_IS* macros in src/*.c files.
795# They're already defined via gnulib's sys/stat.h replacement.
796sc_prohibit_S_IS_definition:
a927b6c1
LC
797 @prohibit='^ *# *define *S_IS' \
798 halt='do not define S_IS* macros; include <sys/stat.h>' \
799 $(_sc_search_regexp)
800
801_ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
802_ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
803# Using test's -a and -o operators is not portable.
804# We prefer test over [, since the latter is spelled [[ in configure.ac.
805sc_prohibit_test_minus_ao:
806 @prohibit='(\<test| \[+) .+ -[ao] ' \
807 halt='$(_ptm1); $(_ptm2)' \
808 $(_sc_search_regexp)
c84bdaf6 809
61cd9dc9
LC
810# Each program that uses proper_name_utf8 must link with one of the
811# ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
812# The perl -0777 invocation below extracts the possibly-multi-line
813# definition of LDADD from the appropriate Makefile.am and exits 0
814# when it contains "ICONV".
c84bdaf6
LC
815sc_proper_name_utf8_requires_ICONV:
816 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
817 if test "x$$progs" != x; then \
818 fail=0; \
819 for p in $$progs; do \
820 dir=$$(dirname "$$p"); \
61cd9dc9
LC
821 perl -0777 \
822 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
823 $$dir/Makefile.am && continue; \
c84bdaf6
LC
824 base=$$(basename "$$p" .c); \
825 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
826 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
827 done; \
828 test $$fail = 1 && \
829 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
830 exit 1; } || :; \
831 fi
832
833# Warn about "c0nst struct Foo const foo[]",
834# but not about "char const *const foo" or "#define const const".
835sc_redundant_const:
a927b6c1
LC
836 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
837 halt='redundant "const" in declarations' \
838 $(_sc_search_regexp)
c84bdaf6
LC
839
840sc_const_long_option:
841 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
842 | grep -Ev 'const struct option|struct option const' && { \
843 echo 1>&2 '$(ME): add "const" to the above declarations'; \
844 exit 1; } || :
845
846NEWS_hash = \
847 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
848 $(srcdir)/NEWS \
61cd9dc9
LC
849 | perl -0777 -pe \
850 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
c84bdaf6
LC
851 | md5sum - \
852 | sed 's/ .*//')
853
854# Ensure that we don't accidentally insert an entry into an old NEWS block.
855sc_immutable_NEWS:
856 @if test -f $(srcdir)/NEWS; then \
857 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
858 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
859 fi
860
861# Update the hash stored above. Do this after each release and
862# for any corrections to old entries.
863update-NEWS-hash: NEWS
864 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
865 $(srcdir)/cfg.mk
866
867# Ensure that we use only the standard $(VAR) notation,
868# not @...@ in Makefile.am, now that we can rely on automake
869# to emit a definition for each substituted variable.
870# We use perl rather than "grep -nE ..." to exempt a single
871# use of an @...@-delimited variable name in src/Makefile.am.
61cd9dc9
LC
872# Allow the package to add exceptions via a hook in cfg.mk;
873# for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
874# setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
875_makefile_at_at_check_exceptions ?=
876sc_makefile_at_at_check:
877 @perl -ne '/\@[A-Z_0-9]+\@/'$(_makefile_at_at_check_exceptions) \
c84bdaf6
LC
878 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
879 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$') \
880 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
881
1cd4fffc 882news-check: NEWS
9157d901
LC
883 if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
884 | grep -E $(news-check-regexp) >/dev/null; then \
c84bdaf6
LC
885 :; \
886 else \
1cd4fffc 887 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
c84bdaf6
LC
888 exit 1; \
889 fi
890
891sc_makefile_TAB_only_indentation:
a927b6c1
LC
892 @prohibit='^ [ ]{8}' \
893 in_vc_files='akefile|\.mk$$' \
894 halt='found TAB-8-space indentation' \
895 $(_sc_search_regexp)
c84bdaf6
LC
896
897sc_m4_quote_check:
a927b6c1
LC
898 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
899 in_vc_files='(^configure\.ac|\.m4)$$' \
900 halt='quote the first arg to AC_DEF*' \
901 $(_sc_search_regexp)
c84bdaf6
LC
902
903fix_po_file_diag = \
904'you have changed the set of files with translatable diagnostics;\n\
905apply the above patch\n'
906
907# Verify that all source files using _() are listed in po/POTFILES.in.
908po_file = po/POTFILES.in
909sc_po_check:
910 @if test -f $(po_file); then \
911 grep -E -v '^(#|$$)' $(po_file) \
912 | grep -v '^src/false\.c$$' | sort > $@-1; \
913 files=; \
914 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
915 test -r $$file || continue; \
916 case $$file in \
917 *.m4|*.mk) continue ;; \
918 *.?|*.??) ;; \
919 *) continue;; \
920 esac; \
921 case $$file in \
922 *.[ch]) \
923 base=`expr " $$file" : ' \(.*\)\..'`; \
924 { test -f $$base.l || test -f $$base.y; } && continue;; \
925 esac; \
926 files="$$files $$file"; \
927 done; \
928 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
929 | sort -u > $@-2; \
930 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
931 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
932 rm -f $@-1 $@-2; \
933 fi
934
935# Sometimes it is useful to change the PATH environment variable
936# in Makefiles. When doing so, it's better not to use the Unix-centric
937# path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
938msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
939sc_makefile_path_separator_check:
a927b6c1
LC
940 @prohibit='PATH[=].*:' \
941 in_vc_files='akefile|\.mk$$' \
942 halt=$(msg) \
943 $(_sc_search_regexp)
c84bdaf6
LC
944
945# Check that `make alpha' will not fail at the end of the process.
946writable-files:
947 if test -d $(release_archive_dir); then :; else \
948 for file in $(distdir).tar.gz \
949 $(release_archive_dir)/$(distdir).tar.gz; do \
950 test -e $$file || continue; \
951 test -w $$file \
952 || { echo ERROR: $$file is not writable; fail=1; }; \
953 done; \
954 test "$$fail" && exit 1 || : ; \
955 fi
956
2e65b52f 957v_etc_file = $(gnulib_dir)/lib/version-etc.c
c84bdaf6
LC
958sample-test = tests/sample-test
959texi = doc/$(PACKAGE).texi
960# Make sure that the copyright date in $(v_etc_file) is up to date.
961# Do the same for the $(sample-test) and the main doc/.texi file.
962sc_copyright_check:
a927b6c1
LC
963 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
964 in_files=$(v_etc_file) \
965 halt='out of date copyright in $(v_etc_file); update it' \
966 $(_sc_search_regexp)
967 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
968 in_vc_files=$(sample-test) \
969 halt='out of date copyright in $(sample-test); update it' \
970 $(_sc_search_regexp)
971 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
972 in_vc_files=$(texi) \
973 halt='out of date copyright in $(texi); update it' \
974 $(_sc_search_regexp)
975
976# If tests/help-version exists and seems to be new enough, assume that its
977# use of init.sh and path_prepend_ is correct, and ensure that every other
978# use of init.sh is identical.
979# This is useful because help-version cross-checks prog --version
980# with $(VERSION), which verifies that its path_prepend_ invocation
981# sets PATH correctly. This is an inexpensive way to ensure that
982# the other init.sh-using tests also get it right.
983_hv_file ?= $(srcdir)/tests/help-version
984_hv_regex_weak ?= ^ *\. .*/init\.sh"
985_hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
986sc_cross_check_PATH_usage_in_tests:
987 @if test -f $(_hv_file); then \
988 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
989 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
990 exit 0; }; \
991 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
992 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
993 exit 1; }; \
994 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
995 grep -LFx "$$good" \
996 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
997 | grep . && \
998 { echo "$(ME): the above files use path_prepend_ inconsistently" \
999 1>&2; exit 1; } || :; \
c84bdaf6
LC
1000 fi
1001
61cd9dc9
LC
1002# #if HAVE_... will evaluate to false for any non numeric string.
1003# That would be flagged by using -Wundef, however gnulib currently
1004# tests many undefined macros, and so we can't enable that option.
1005# So at least preclude common boolean strings as macro values.
1006sc_Wundef_boolean:
a927b6c1
LC
1007 @prohibit='^#define.*(yes|no|true|false)$$' \
1008 in_files='$(CONFIG_INCLUDE)' \
1009 halt='Use 0 or 1 for macro values' \
1010 $(_sc_search_regexp)
61cd9dc9
LC
1011
1012sc_vulnerable_makefile_CVE-2009-4029:
a927b6c1
LC
1013 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1014 in_files=$$(find $(srcdir) -name Makefile.in) \
1015 halt='the above files are vulnerable; beware of running\n'\
1016'"make dist*" rules, and upgrade to fixed automake\n'\
1017'see http://bugzilla.redhat.com/542609 for details' \
1018 $(_sc_search_regexp)
61cd9dc9 1019
c84bdaf6
LC
1020vc-diff-check:
1021 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1022 if test -s vc-diffs; then \
1023 cat vc-diffs; \
1024 echo "Some files are locally modified:" 1>&2; \
1025 exit 1; \
1026 else \
1027 rm vc-diffs; \
1028 fi
1029
c84bdaf6
LC
1030rel-files = $(DIST_ARCHIVES)
1031
1032gnulib_dir ?= $(srcdir)/gnulib
1033gnulib-version = $$(cd $(gnulib_dir) && git describe)
1034bootstrap-tools ?= autoconf,automake,gnulib
1035
61cd9dc9
LC
1036# If it's not already specified, derive the GPG key ID from
1037# the signed tag we've just applied to mark this release.
1038gpg_key_ID ?= \
1039 $$(git cat-file tag v$(VERSION) > .ann-sig \
1040 && gpgv .ann-sig - < /dev/null 2>&1 \
1041 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1042
a927b6c1
LC
1043translation_project_ ?= coordinator@translationproject.org
1044announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1045announcement_mail_headers_ ?= \
1046To: info-gnu@gnu.org \
1047Cc: $(announcement_Cc_) \
1048Mail-Followup-To: $(PACKAGE_BUGREPORT)
1049
c84bdaf6
LC
1050announcement: NEWS ChangeLog $(rel-files)
1051 @$(build_aux)/announce-gen \
a927b6c1 1052 --mail-headers='$(announcement_mail_headers_)' \
c84bdaf6
LC
1053 --release-type=$(RELEASE_TYPE) \
1054 --package=$(PACKAGE) \
1055 --prev=$(PREV_VERSION) \
1056 --curr=$(VERSION) \
1057 --gpg-key-id=$(gpg_key_ID) \
61cd9dc9 1058 --news=$(srcdir)/NEWS \
c84bdaf6
LC
1059 --bootstrap-tools=$(bootstrap-tools) \
1060 --gnulib-version=$(gnulib-version) \
1061 --no-print-checksums \
1062 $(addprefix --url-dir=, $(url_dir_list))
1063
1064## ---------------- ##
1065## Updating files. ##
1066## ---------------- ##
1067
1068ftp-gnu = ftp://ftp.gnu.org/gnu
1069www-gnu = http://www.gnu.org
1070
dde9c5a4 1071upload_dest_dir_ ?= $(PACKAGE)
c84bdaf6
LC
1072emit_upload_commands:
1073 @echo =====================================
1074 @echo =====================================
1075 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
dde9c5a4 1076 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
c84bdaf6 1077 @echo " $(rel-files)"
61cd9dc9 1078 @echo '# send the ~/announce-$(my_distdir) e-mail'
c84bdaf6
LC
1079 @echo =====================================
1080 @echo =====================================
1081
1082noteworthy = * Noteworthy changes in release ?.? (????-??-??) [?]
1083define emit-commit-log
1084 printf '%s\n' 'post-release administrivia' '' \
1085 '* NEWS: Add header line for next release.' \
1086 '* .prev-version: Record previous version.' \
1087 '* cfg.mk (old_NEWS_hash): Auto-update.'
1088endef
1089
1090.PHONY: no-submodule-changes
1091no-submodule-changes:
1092 if test -d $(srcdir)/.git; then \
1093 diff=$$(cd $(srcdir) && git submodule -q foreach \
1094 git diff-index --name-only HEAD) \
1095 || exit 1; \
1096 case $$diff in '') ;; \
1097 *) echo '$(ME): submodule files are locally modified:'; \
1098 echo "$$diff"; exit 1;; esac; \
1099 else \
1100 : ; \
1101 fi
1102
1103.PHONY: alpha beta stable
1104ALL_RECURSIVE_TARGETS += alpha beta stable
1105alpha beta stable: $(local-check) writable-files no-submodule-changes
1106 test $@ = stable \
1107 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1108 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1109 || :
1110 $(MAKE) vc-diff-check
1cd4fffc 1111 $(MAKE) news-check
c84bdaf6
LC
1112 $(MAKE) distcheck
1113 $(MAKE) dist XZ_OPT=-9ev
1cd4fffc
LC
1114 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1115 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1116
1117# Override this in cfg.mk if you follow different procedures.
1118release-prep-hook ?= release-prep
1119
1120.PHONY: release-prep
1121release-prep:
1122 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1123 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
61cd9dc9 1124 $(MAKE) -s announcement > ~/announce-$(my_distdir)
c84bdaf6
LC
1125 if test -d $(release_archive_dir); then \
1126 ln $(rel-files) $(release_archive_dir); \
1127 chmod a-w $(rel-files); \
1128 fi
c84bdaf6
LC
1129 echo $(VERSION) > $(prev_version_file)
1130 $(MAKE) update-NEWS-hash
1131 perl -pi -e '$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
1132 $(emit-commit-log) > .ci-msg
1133 $(VC) commit -F .ci-msg -a
61cd9dc9 1134 rm .ci-msg
c84bdaf6 1135
a927b6c1
LC
1136# Override this with e.g., -s $(srcdir)/some_other_name.texi
1137# if the default $(PACKAGE)-derived name doesn't apply.
1138gendocs_options_ ?=
1139
c84bdaf6
LC
1140.PHONY: web-manual
1141web-manual:
1142 @test -z "$(manual_title)" \
1143 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1144 @cd '$(srcdir)/doc'; \
a927b6c1
LC
1145 $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1146 -o '$(abs_builddir)/doc/manual' \
c84bdaf6
LC
1147 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1148 "$(PACKAGE_NAME) - $(manual_title)"
1149 @echo " *** Upload the doc/manual directory to web-cvs."
1150
1151# Code Coverage
1152
1153init-coverage:
1154 $(MAKE) $(AM_MAKEFLAGS) clean
1155 lcov --directory . --zerocounters
1156
1157COVERAGE_CCOPTS ?= "-g --coverage"
1158COVERAGE_OUT ?= doc/coverage
1159
1160build-coverage:
1161 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1162 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1163 mkdir -p $(COVERAGE_OUT)
1164 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1165 --capture
1166
1167gen-coverage:
1168 genhtml --output-directory $(COVERAGE_OUT) \
1169 $(COVERAGE_OUT)/$(PACKAGE).info \
1170 --highlight --frames --legend \
1171 --title "$(PACKAGE_NAME)"
1172
1173coverage: init-coverage build-coverage gen-coverage
1174
1175# Update gettext files.
1176PACKAGE ?= $(shell basename $(PWD))
1177PO_DOMAIN ?= $(PACKAGE)
1178POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1179PODIR ?= po
1180refresh-po:
1181 rm -f $(PODIR)/*.po && \
1182 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1183 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1184 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1185 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1186 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1187
a927b6c1 1188 # Running indent once is not idempotent, but running it twice is.
c84bdaf6
LC
1189INDENT_SOURCES ?= $(C_SOURCES)
1190.PHONY: indent
1191indent:
1192 indent $(INDENT_SOURCES)
a927b6c1 1193 indent $(INDENT_SOURCES)
c84bdaf6
LC
1194
1195# If you want to set UPDATE_COPYRIGHT_* environment variables,
1196# put the assignments in this variable.
1197update-copyright-env ?=
1198
1199# Run this rule once per year (usually early in January)
1200# to update all FSF copyright year lists in your project.
1201# If you have an additional project-specific rule,
1202# add it in cfg.mk along with a line 'update-copyright: prereq'.
1203# By default, exclude all variants of COPYING; you can also
1204# add exemptions (such as ChangeLog..* for rotated change logs)
1205# in the file .x-update-copyright.
1206.PHONY: update-copyright
1207update-copyright:
1208 grep -l -w Copyright \
1209 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1210 | $(update-copyright-env) xargs $(build_aux)/$@